/* Copyright 2009 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: AppState.h 3 2009-04-18 17:03:31Z tonic $
 * $Revision: 3 $
 */

#ifndef APPSTATE_H_INCL
#define APPSTATE_H_INCL


enum APPSTATE_ENUM
{
    APPSTATE_DEFAULT_FPS = 60
};


class AppState
{
public:

    AppState() : mFPS(APPSTATE_DEFAULT_FPS),
                 mTime(0), mStartTime(0), mPaused(false) {}
    virtual ~AppState() {}

    virtual bool init() { return true; }
    virtual void deinit() {}

    UI32 getUpdateFPS() { return mFPS; }

    virtual bool update(UI32 time);
    virtual void render(irr::IrrlichtDevice *device) = 0;

    virtual void onActivate(UI32 /*time*/) { mTime = mStartTime = 0; mPaused = false; }
    virtual void onDeactivate() {}

    virtual bool onKeyDown(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onKeyUp(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onMouseDown(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseUp(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseMotion(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseWheel(const irr::SEvent::SMouseInput &event) { return false; }
    //virtual void onFocusLost(const SDL_ActiveEvent &event) {}
    //virtual void onFocusGain(const SDL_ActiveEvent &event) {}

protected:

    UI32 mFPS;
    UI32 mTime;
    I32 mStartTime;
    bool mPaused;
};


#endif // !APPSTATE_H_INCL
